## dynamips 0.2.7

=== Makefile ===
# Makefile for Dynamips 0.2.8
# Copyright (c) 2005-2006 Christophe Fillot.

# Replace x86 by amd64 for a build on x86_64.
# Use "nojit" for architectures that are not x86 or x86_64.
DYNAMIPS_ARCH?=x86

# Change this to 0 if your system doesn't support RFC 2553 extensions
HAS_RFC2553?=1

# Change this to 1 if your system has libpcap-0.9.4 or better 
# (WinPcap is used for Cygwin)
HAS_PCAP?=1

# Change this to 1 if your system has posix_memalign
HAS_POSIX_MEMALIGN?=0

# Current dynamips release
VERSION_TRAIN=0.2.8
VERSION_SUB=-RC2

VERSION=$(VERSION_TRAIN)$(VERSION_SUB)
VERSION_DEV=$(VERSION_TRAIN)-$(shell date +%Y%m%d-%H)

# Executable binary extension
DESTDIR?=/usr
BIN_EXT?=

CC?=gcc
LD=ld
RM=rm
TAR=tar
CP=cp
LEX=flex
MIPS64_ARCH_INC_FILE=\"mips64_$(DYNAMIPS_ARCH)_trans.h\"
PPC32_ARCH_INC_FILE=\"ppc32_$(DYNAMIPS_ARCH)_trans.h\"

CFLAGS+=-g -Wall -O3 -fomit-frame-pointer \
	-DJIT_ARCH=\"$(DYNAMIPS_ARCH)\" -DJIT_CPU=CPU_$(DYNAMIPS_ARCH) \
	-DMIPS64_ARCH_INC_FILE=$(MIPS64_ARCH_INC_FILE) \
	-DPPC32_ARCH_INC_FILE=$(PPC32_ARCH_INC_FILE) \
	-DDYNAMIPS_VERSION=\"$(VERSION)\" \
	-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE \
	-DHAS_RFC2553=$(HAS_RFC2553) \
	-DHAS_POSIX_MEMALIGN=$(HAS_POSIX_MEMALIGN)

#PCAP_LIB=/usr/local/lib/libpcap.a
PCAP_LIB=-lpcap

ifeq ($(shell uname), FreeBSD)
   PTHREAD_LIBS?=-pthread
   LOCALBASE?=/usr/local
   CFLAGS+=-I$(LOCALBASE)/include -I$(LOCALBASE)/include/libelf \
	$(PTHREAD_CFLAGS) -D_FILE_OFFSET_BITS=64
   LIBS=-L$(LOCALBASE)/lib -L. -ldl -lelf $(PTHREAD_LIBS) $(LDFLAGS)
else
ifeq ($(shell uname), Linux)
   PTHREAD_LIBS?=-lpthread
#   PCAP_LIB=-lpcap
   CFLAGS+=-I/usr/include -I. $(PTHREAD_CFLAGS)
   LIBS=-L/usr/lib -L. -ldl /usr/lib/libelf.a $(PTHREAD_LIBS)
   DESTDIR=/usr
else
ifeq ($(shell uname -s), Darwin)
   CFLAGS+=-I/usr/local/include -mdynamic-no-pic -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/local/lib -L. -ldl -lelf -lpthread
else
ifeq ($(shell uname -s), SunOS)
   CFLAGS+=-I/usr/local/include -DINADDR_NONE=0xFFFFFFFF \
	-I /opt/csw/include -DSUNOS
   LIBS=-L/usr/local/lib -L. -ldl -lelf -lpthread -L/opt/csw/lib \
	-lsocket -lnsl -lresolv
   PCAP_LIB=/opt/csw/lib/libpcap.a
else
ifeq ($(shell uname -o), Cygwin)
   CFLAGS+=-I/usr/local/include -I/usr/local/include/libelf -DCYGWIN \
	-D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/local/lib -L. -lelf -lpthread
   PCAP_LIB=-lpacket -lwpcap
else
   CFLAGS+=-I/usr/include/libelf -D_FILE_OFFSET_BITS=64
   LIBS=-L. -ldl /usr/lib/libelf.a -lpthread
endif
endif
endif
endif
endif

PROG=dynamips$(BIN_EXT)
PACKAGE=$(PROG)-$(VERSION)
ARCHIVE=$(PACKAGE).tar.gz

PACKAGE_DEV=$(PROG)-$(VERSION_DEV)
ARCHIVE_DEV=$(PACKAGE_DEV).tar.gz

# Header and source files
HDR=mempool.h registry.h rbtree.h hash.h utils.h parser.h plugin.h \
	crc.h sbox.h base64.h net.h net_io.h net_io_bridge.h net_io_filter.h \
	atm.h atm_vsar.h atm_bridge.h frame_relay.h eth_switch.h \
	ptask.h timer.h dev_vtty.h hypervisor.h dynamips.h insn_lookup.h \
	vm.h cpu.h jit_op.h memory.h device.h \
	mips64.h mips64_mem.h mips64_exec.h mips64_jit.h mips64_cp0.h \
	ppc32.h ppc32_mem.h ppc32_exec.h ppc32_jit.h ppc32_vmtest.h \
	nmc93cX6.h cisco_eeprom.h cisco_card.h ds1620.h dev_rom.h \
	pci_dev.h pci_io.h dev_mpc860.h dev_gt.h dev_mv64460.h dev_plx.h \
	dev_dec21140.h dev_am79c971.h dev_i8254x.h dev_i8255x.h \
	dev_mueslix.h dev_nm_16esw.h dev_wic_serial.h \
	dev_c7200.h dev_c7200_mpfpga.h \
	dev_c3600.h dev_c3600_iofpga.h dev_c3600_bay.h \
	dev_c2691.h dev_c2691_iofpga.h \
	dev_c3725.h dev_c3725_iofpga.h \
	dev_c3745.h dev_c3745_iofpga.h \
	dev_c2600.h dev_c2600_iofpga.h \
	dev_c1700.h dev_c1700_iofpga.h \
	dev_c6msfc1.h dev_c6msfc1_mpfpga.h \
	dev_c6sup1.h dev_c6sup1_mpfpga.h \
	rommon_var.h

SOURCES=mempool.c registry.c rbtree.c hash.c sbox.c utils.c parser.c \
	plugin.c ptask.c timer.c crc.c base64.c \
	net.c net_io.c net_io_bridge.c net_io_filter.c \
	atm.c atm_vsar.c atm_bridge.c frame_relay.c eth_switch.c \
	dynamips.c insn_lookup.c vm.c cpu.c jit_op.c \
	mips64.c mips64_mem.c mips64_cp0.c mips64_jit.c mips64_exec.c \
	ppc32.c ppc32_mem.c ppc32_jit.c ppc32_exec.c ppc32_vmtest.c \
	memory.c device.c nmc93cX6.c cisco_eeprom.c cisco_card.c \
	pci_dev.c pci_io.c \
	dev_zero.c dev_bswap.c dev_vtty.c dev_ram.c dev_rom.c dev_nvram.c \
	dev_bootflash.c dev_flash.c dev_mpc860.c \
	dev_remote.c dev_clpd6729.c dev_pcmcia_disk.c dev_gt.c dev_mv64460.c \
	dev_plx.c dev_dec21x50.c dev_pericom.c dev_ti2050b.c dev_ap1011.c \
	dev_plx6520cb.c dev_ns16552.c \
	dev_dec21140.c dev_am79c971.c dev_i8254x.c dev_i8255x.c \
	dev_mueslix.c dev_wic_serial.c \
	dev_c3600.c dev_c3600_bay.c dev_c3600_iofpga.c \
	dev_c3600_eth.c dev_c3600_serial.c \
	dev_c7200.c dev_c7200_iofpga.c dev_c7200_mpfpga.c \
	dev_c7200_sram.c dev_c7200_eth.c dev_c7200_serial.c dev_c7200_pos.c \
	dev_c7200_bri.c \
	dev_c2691.c dev_c2691_iofpga.c dev_c2691_eth.c dev_c2691_serial.c \
	dev_c2691_wic.c dev_c2691_pcmod.c \
	dev_c3725.c dev_c3725_iofpga.c dev_c3725_eth.c dev_c3725_serial.c \
	dev_c3725_wic.c dev_c3725_pcmod.c \
	dev_c3745.c dev_c3745_iofpga.c dev_c3745_eth.c dev_c3745_serial.c \
	dev_c3745_wic.c dev_c3745_pcmod.c \
	dev_c2600.c dev_c2600_pci.c dev_c2600_iofpga.c \
	dev_c2600_eth.c dev_c2600_pcmod.c dev_c2600_wic.c \
	dev_c1700.c dev_c1700_iofpga.c dev_c1700_eth.c dev_c1700_wic.c \
	dev_c6msfc1.c dev_c6msfc1_iofpga.c dev_c6msfc1_mpfpga.c \
	dev_c6sup1.c dev_c6sup1_iofpga.c dev_c6sup1_mpfpga.c \
	dev_nm_16esw.c dev_pa_a1.c dev_pa_mc8te1.c \
	dev_sb1.c dev_sb1_io.c dev_sb1_pci.c hypervisor.c \
	hv_nio.c hv_nio_bridge.c \
	hv_frsw.c hv_atmsw.c hv_atm_bridge.c hv_ethsw.c \
	hv_vm.c hv_vm_debug.c hv_store.c \
	hv_c7200.c hv_c3600.c hv_c2691.c hv_c3725.c hv_c3745.c \
	hv_c2600.c hv_c1700.c \
	rommon_var.c

# Profiling
#SOURCES += profiler.c
#CFLAGS += -p -DPROFILE -DPROFILE_FILE=\"$(PROG).profile\"

ifeq ($(DYNAMIPS_ARCH),x86)
HDR += x86-codegen.h mips64_x86_trans.h ppc32_x86_trans.h
SOURCES += mips64_x86_trans.c ppc32_x86_trans.c
endif

ifeq ($(DYNAMIPS_ARCH),amd64)
HDR += x86-codegen.h amd64-codegen.h mips64_amd64_trans.h ppc32_amd64_trans.h
SOURCES += mips64_amd64_trans.c ppc32_amd64_trans.c
endif

ifeq ($(DYNAMIPS_ARCH),nojit)
HDR += mips64_nojit_trans.h ppc32_nojit_trans.h
SOURCES += mips64_nojit_trans.c ppc32_nojit_trans.c
endif

# RAW Ethernet support for Linux
ifeq ($(shell uname), Linux)
CFLAGS += -DLINUX_ETH
HDR += linux_eth.h
SOURCES += linux_eth.c
endif

# Generic Ethernet support with libpcap (0.9+)
ifeq ($(HAS_PCAP), 1)
CFLAGS += -DGEN_ETH
HDR += gen_eth.h
SOURCES += gen_eth.c

LIBS += $(PCAP_LIB)
endif

C_OBJS=$(SOURCES:.c=.o)
A_OBJS=$(ASMSRC:.S=.o)
LEX_C=$(LEX_SOURCES:.l=.c)

SUPPL=mips_mts.c Makefile ChangeLog COPYING README README.hypervisor TODO \
	dynamips.1 nvram_export.1 hypervisor_mode.7 \
	mips64_microcode ppc32_microcode debian/

FILE_LIST := $(HDR) $(SOURCES) $(SUPPL) \
	x86-codegen.h amd64-codegen.h \
	mips64_x86_trans.c mips64_x86_trans.h \
	mips64_amd64_trans.c mips64_amd64_trans.h \
	mips64_nojit_trans.c mips64_nojit_trans.h \
	ppc32_x86_trans.c ppc32_x86_trans.h \
	ppc32_amd64_trans.c ppc32_amd64_trans.h \
	ppc32_nojit_trans.c ppc32_nojit_trans.h \
	linux_eth.c linux_eth.h gen_eth.c gen_eth.h \
	profiler.c profiler_resolve.pl bin2c.c rom2c.c \
	nvram_export.c udp_send.c udp_recv.c

.PHONY: all
all: $(PROG) nvram_export

$(PROG): mips64_microcode_dump.inc ppc32_microcode_dump.inc \
	$(LEX_C) $(C_OBJS) $(A_OBJS)
	@echo "Linking $@"
	@$(CC) -o $@ $(C_OBJS) $(A_OBJS) $(LIBS)

udp_send$(BIN_EXT): udp_send.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_send.c net.c crc.c $(LIBS)

udp_recv$(BIN_EXT): udp_recv.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_recv.c net.c crc.c $(LIBS)

rom2c$(BIN_EXT): rom2c.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ rom2c.c $(LIBS)

mips64_microcode_dump.inc: rom2c$(BIN_EXT) mips64_microcode
	@./rom2c mips64_microcode mips64_microcode_dump.inc 0xbfc00000

ppc32_microcode_dump.inc: rom2c$(BIN_EXT) ppc32_microcode
	@./rom2c ppc32_microcode ppc32_microcode_dump.inc 0xfff00000

asmdefs$(BIN_EXT): asmdefs.c mips64.h
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ asmdefs.c

asmdefs.h: asmdefs$(BIN_EXT)
	@echo "Building assembly definitions header file"
	@./asmdefs

nvram_export$(BIN_EXT): nvram_export.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ nvram_export.c

install: $(PROG) nvram_export
	@echo "Installing"
	install -d $(DESTDIR)/bin $(DESTDIR)/man/man1 $(DESTDIR)/man/man7 $(DESTDIR)/etc
	install dynamips nvram_export   $(DESTDIR)/bin
	install -m644 dynamips.1        $(DESTDIR)/man/man1
	install -m644 nvram_export.1    $(DESTDIR)/man/man1
	install -m644 hypervisor_mode.7 $(DESTDIR)/man/man7
# install -m644 example         $(DESTDIR)/etc/dynamips


.PHONY: clean
clean:
	$(RM) -f rom2c$(BIN_EXT) microcode_dump.inc asmdefs$(BIN_EXT) \
	asmdefs.h $(C_OBJS) $(A_OBJS) $(PROG)
	$(RM) -f *~

.PHONY: package
package:
	@mkdir -p distrib/$(PACKAGE)
	@$(CP) -r $(FILE_LIST) distrib/$(PACKAGE)
	@cd distrib ; $(TAR) czf $(ARCHIVE) $(PACKAGE)

.PHONY: packdev
packdev:
	@mkdir -p distrib/$(PACKAGE_DEV)
	@$(CP) -r $(FILE_LIST) distrib/$(PACKAGE_DEV)
	@cd distrib ; $(TAR) czf $(ARCHIVE_DEV) $(PACKAGE_DEV)

.SUFFIXES: .c .h .S .l .y .o

.S.o:
	@echo "Assembling $<"
	@$(CC) $(CFLAGS) $(INCLUDE) -c -o $*.o $<

.c.o:
	@echo "Compiling $<"
	@$(CC) $(CFLAGS) $(INCLUDE) -c -o $*.o $<

.l.c:
	$(LEX) -o$*.c $<

## dynamips 0.2.7-0.2.8RC2

=== debian/changelog ===
dynamips (0.2.7-0.2.8RC2-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix "FTBFS with multiarch paths: cc: error: /usr/lib/libelf.a: No
    such file or directory": add patch libelf.patch: just use "-lelf".
    (Closes: #682412).
    Thanks to gregor herrmann for providing a patch.

 -- Arno Töll <arno@debian.org>  Sat, 15 Sep 2012 20:55:37 +0200

dynamips (0.2.7-0.2.8RC2-5) unstable; urgency=low

  * [36efa51e] changed patch system from dpatch to quilt
  * [810c744d] [debian/control] bumped standards version

 -- Erik Wenzel <erik@debian.org>  Fri, 10 Sep 2010 23:12:09 +0000

dynamips (0.2.7-0.2.8RC2-4) unstable; urgency=low

  * [5530548a] [patch] added 70_console_bind to allow binds to a
    configurable inet address (Closes: #504669) - thanks to Justin Azoff
    <JAzoff@uamail.albany.edu>
  * [88fd2973] changed file modes in patch dir und removed extra cleanup
    in clean target of rules

 -- Erik Wenzel <erik@debian.org>  Wed, 04 Feb 2009 22:26:05 +0100

dynamips (0.2.7-0.2.8RC2-3) unstable; urgency=low

  * [1a8805d8] [rules] added mode fix for debian patches in clean target
  * [064d8cd6] [control] bumped standards-version; added
    debian/README.source
  * [de110875] [rules] removed architecture fixes
  * [fd03c6f8] integrated 90_fix_Makefile_architectures from ubuntu
    (Closes: 468797) - thanks to Luca Falavigna <dktrkranz@ubuntu.com>
  * [4113547e] integraded 91_hppa_support.dpatch from ubuntu - thanks to
    Luca Falavigna <dktrkranz@ubuntu.com>
  * [87845f36] [control] added vcs fields
  * [b9556304] [control] added misc:depends as lintian suggests
  * [fcdd1b50] [control] fixed typo in depends line
  * [f8766421] removed empty {post,pre}{inst,rm}

 -- Erik Wenzel <erik@debian.org>  Thu, 22 Jan 2009 00:29:33 +0100

dynamips (0.2.7-0.2.8RC2-2) unstable; urgency=low

  * [control] added DebTags
  * [control] bumped standards-version
  * [control] added Homepage field
  * [control] fixed Build dependency
  * [copyright] added years
  * added 65_man_macro_fixes.dpatch

 -- Erik Wenzel <erik@debian.org>  Thu, 27 Mar 2008 23:28:47 +0000

dynamips (0.2.7-0.2.8RC2-1) unstable; urgency=low

  * New upstream release
  * [hypervisor_mode.7] fixed NAME for mandb update on whatis and
    apropos
  * [control] added gns3 client information

 -- Erik Wenzel <erik@debian.org>  Wed, 17 Oct 2007 06:22:05 +0000

dynamips (0.2.7-0.2.8RC1-1) unstable; urgency=low

  * New upstream release
  * [control] changed description

 -- Erik Wenzel <erik@debian.org>  Mon, 10 Sep 2007 11:17:29 +0000

dynamips (0.2.7-1) unstable; urgency=low

  * New upstream release
  * [control] removed uploader

 -- Erik Wenzel <erik@debian.org>  Fri, 15 Jun 2007 15:42:44 +0000

dynamips (0.2.6-0.2.7RC3-1) unstable; urgency=low

  * New upstream release
  * created 40_fix_Makefile_linux_pcap_path patch
  * lintian: fixed typo in README.Debian

 -- Erik Wenzel <erik@debian.org>  Sun, 06 May 2007 09:29:17 +0000

dynamips (0.2.6-0.2.7RC1-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Wed, 21 Feb 2007 19:11:37 +0100

dynamips (0.2.5-0.2.6RC5-2) unstable; urgency=low

  * [control] changed section to non-free
  * Initial release. (Closes: #383068)
  * corrected version string
  * [copyright] updated license statements on 2 header files

 -- Erik Wenzel <erik@debian.org>  Sat, 13 Jan 2007 15:16:50 +0000

dynamips (0.2.6RC5-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Thu, 21 Dec 2006 14:08:21 +0000

dynamips (0.2.6RC4-1) unstable; urgency=low

  * new upstream release
  * changed dependency from libelfg0-dev to libelf-dev
  * removed 10_makefile_install_target.dpatch. integrated in upstream
  * removed 15_makefile_man_targets.dpatch. partly integrated in upstream
  * renamed 20_fix_Makefile_clean_target.dpatch
  * created 30_fix_Makefile_man_path.dpatch
  * created 35_fix_Makefile_etc.dpatch
  * removed debian/ dir shipped with upstream release

 -- Erik Wenzel <erik@debian.org>  Mon, 20 Nov 2006 00:29:25 +0100

dynamips (0.2.6RC2-2) unstable; urgency=low

  * Upstream included COPYING file with GNU Licence statement in v0.2.5
    (Closes: #383068)
  * watch file added
  * removed man pages from debian/, upstream included it in tarball
  * using dpatch now
  * created 10_makefile_install_target.dpatch
  * created 15_makefile_man_targets.dpatch: ifdef for Linux inspired by
    "Achim Dreyer" <adreyer@adreyer.de>, thanks.
  * created 20_fix_clean_target.dpatch
  * created 30_use_sharedlib.dpatch
  * install README.hypervisor doc directory

 -- Erik Wenzel <erik@debian.org>  Mon, 23 Oct 2006 00:45:34 +0200

dynamips (0.2.6RC2-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Thu, 19 Oct 2006 16:21:04 +0200

dynamips (0.2.6RC1-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Sun, 15 Oct 2006 23:02:03 +0200

dynamips (0.2.5-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Sat, 16 Sep 2006 14:27:20 +0200

dynamips (0.2.4-0.2.5RC5-2) unstable; urgency=low

  * included nvram_export installation in Makefile patch
  * dynamips man page written
  * nvram_export man page written
  * hypervisor_mode man page written

 -- Erik Wenzel <erik@debian.org>  Sun, 10 Sep 2006 23:15:58 +0200

dynamips (0.2.4-0.2.5RC5-1) unstable; urgency=low

  * New upstream release

 -- Erik Wenzel <erik@debian.org>  Tue,  5 Sep 2006 08:31:51 +0200

dynamips (0.2.4-0.2.5RC2-2) unstable; urgency=low

  * [control]: Changed Section to contrib/net
  * [copyright]: added copyright information on header files

 -- Erik Wenzel <erik@debian.org>  Mon, 21 Aug 2006 11:56:23 +0200

dynamips (0.2.4-0.2.5RC2-1) unstable; urgency=low

  * Initial release. (Closes: #383068)
  * created control, copyright, rules, changelog files
  * Patch written: Makefile_install_target

 -- Erik Wenzel <erik@debian.org>  Tue,  15 Aug 2006 22:11:56 +0200

=== debian/control ===
Source: dynamips
Section: non-free/net
Priority: optional
Maintainer: Erik Wenzel <erik@debian.org>
Homepage: http://www.ipflow.utc.fr/
Build-Depends: cdbs (>= 0.4.25), quilt (>= 0.40), debhelper (>= 5.0), libpcap0.8-dev (>= 0.9.0), libelf-dev
Vcs-Git: git://gpl.code.de/git/dynamips
Vcs-Browser: http://gpl.code.de/gitweb?p=dynamips.git;a=summary
Standards-Version: 3.9.1

Package: dynamips
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cisco 7200/3600/3725/3745/2600/1700 Router Emulator
 Dynamips emulates Cisco 7200/3600/3725/3745/2600/1700 Routers on a traditional
 PC.  You can use dynamips to create labs. It uses IOS Images (which are not
 part of this package). Of course, this emulator cannot replace a real router.
 It is simply a complementary tool to real labs for administrators of Cisco
 networks or people wanting to pass their CCNA/CCNP/CCIE exams. For a Command
 Line Interface for dynamips see dynagen or gns3 package.
Tag: hardware::emulation, implemented-in::c, interface::commandline, interface::daemon, interface::shell, network::TODO, network::routing, network::server, protocol::atm, protocol::ethernet, protocol::ip, protocol::ipv6, role::program, scope::utility, use::checking, use::learning, use::routing, works-with::network-traffic

=== debian/rules ===
#!/usr/bin/make -f
# Copyright © 2003 Colin Walters <walters@verbum.org>
# Copyright © 2004, 2005, 2006 Loic Minier <lool@dooz.org>

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk
include /usr/share/cdbs/1/class/makefile.mk

# define clean taget
DEB_MAKE_CLEAN_TARGET = clean

DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) make -C $(DEB_BUILDDIR)

DEB_MAKE_INSTALL_TARGET = install DESTDIR=$(CURDIR)/debian/dynamips/usr/

cleanbuilddir::
	-rm nvram_export
	-rm *.o

## dynamips 0.2.11

=== Makefile ===
# Makefile for Dynamips

# Host CPU selection
#   - Use "x86" for a build on x86 (32-bits)
#   - Use "amd64" for a build on x86_64 (64-bits)
#   - Use "nojit" for unsupported architectures.
ifeq ($(shell arch),x86_64)
export DYNAMIPS_ARCH?=amd64
else
ifeq ($(shell arch),i686)
export DYNAMIPS_ARCH?=x86
else
export DYNAMIPS_ARCH?=nojit
endif
endif

# For MAC x64 you can compile the "unstable" version, which should work
# fine, or use stable if you prefer.
# For all other targets you should really choose "stable" here.
# Unstable has some optimizations in it, plus new TLA code.
# However it does not seem stable for non-mac users
export DYNAMIPS_CODE?=stable

# Change this to 0 if your system doesn't support RFC2553 extensions
export HAS_RFC2553?=1

# Change this to 1 if your system has libpcap-0.9.4 or better 
# (WinPcap is used for Cygwin)
export HAS_PCAP?=1

# Change this to 1 if your system has posix_memalign
export HAS_POSIX_MEMALIGN?=1

# Current dynamips release
export VERSION_TRAIN=0.2.11
export VERSION_SUB=

# Executable binary extension and prefix directory
export PREFIX?=/usr
export BIN_EXT?=


.PHONY: all dynamips.stable dynamips.unstable both install clean
all: dynamips.$(DYNAMIPS_CODE)

dynamips.stable:
	$(MAKE) -C stable
	mv stable/dynamips$(BIN_EXT) dynamips.stable$(BIN_EXT)
	mv stable/nvram_export$(BIN_EXT) nvram_export.stable$(BIN_EXT) 

dynamips.unstable:
	$(MAKE) -C unstable
	mv unstable/dynamips$(BIN_EXT) dynamips.unstable$(BIN_EXT)
	mv unstable/nvram_export$(BIN_EXT) nvram_export.unstable$(BIN_EXT) 

# target to facilitate test compilations
both: dynamips.stable dynamips.unstable

install: dynamips.$(DYNAMIPS_CODE)$(BIN_EXT) nvram_export.$(DYNAMIPS_CODE)$(BIN_EXT)
	@echo "Installing"
	
	cp dynamips.$(DYNAMIPS_CODE)$(BIN_EXT) dynamips$(BIN_EXT)
	cp nvram_export.$(DYNAMIPS_CODE)$(BIN_EXT) nvram_export$(BIN_EXT)
	
	install -d $(DESTDIR)$(PREFIX)/bin $(DESTDIR)$(PREFIX)/share/man/man1 $(DESTDIR)$(PREFIX)/share/man/man7
	install dynamips$(BIN_EXT) nvram_export$(BIN_EXT) $(DESTDIR)$(PREFIX)/bin/
	install -m644 man/dynamips.1        $(DESTDIR)$(PREFIX)/share/man/man1
	install -m644 man/nvram_export.1    $(DESTDIR)$(PREFIX)/share/man/man1
	install -m644 man/hypervisor_mode.7 $(DESTDIR)$(PREFIX)/share/man/man7

clean:
	$(MAKE) -C stable clean
	$(MAKE) -C unstable clean
	$(RM) -f dynamips$(BIN_EXT) dynamips.stable$(BIN_EXT) dynamips.unstable$(BIN_EXT)
	$(RM) -f nvram_export$(BIN_EXT) nvram_export.stable$(BIN_EXT) nvram_export.unstable$(BIN_EXT)

=== stable/Makefile ===
# Stable Makefile for Dynamips
# Copyright (c) 2005-2006 Christophe Fillot.
# Copyright (c) 2013 Daniel Lintott.

# Get include files from the current directory and from the common directory
INCLUDE+=-I. -I../common

VERSION=$(VERSION_TRAIN)$(VERSION_SUB)
VERSION_DEV=$(VERSION_TRAIN)-$(shell date +%Y%m%d-%H)

# If make cannot find a file, try the common directory
VPATH = ../common

CC?=gcc
RM=rm
TAR=tar
CP=cp
MIPS64_ARCH_INC_FILE=\"mips64_$(DYNAMIPS_ARCH)_trans.h\"
PPC32_ARCH_INC_FILE=\"ppc32_$(DYNAMIPS_ARCH)_trans.h\"
OSNAME=unknown

CFLAGS+= $(INCLUDE) -Wall -O2 -fomit-frame-pointer \
	-DJIT_ARCH=\"$(DYNAMIPS_ARCH)\" -DJIT_CPU=CPU_$(DYNAMIPS_ARCH) \
	-DMIPS64_ARCH_INC_FILE=$(MIPS64_ARCH_INC_FILE) \
	-DPPC32_ARCH_INC_FILE=$(PPC32_ARCH_INC_FILE) \
	-DDYNAMIPS_VERSION=\"$(VERSION)\" \
	-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE \
	-DHAS_RFC2553=$(HAS_RFC2553) \
	-DHAS_POSIX_MEMALIGN=$(HAS_POSIX_MEMALIGN)

PCAP_LIB?=-lpcap

ifeq ($(shell uname), FreeBSD)
   PTHREAD_LIBS?=-pthread
   LOCALBASE?=/usr/local
   OSNAME=FreeBSD
   CFLAGS+=-I$(LOCALBASE)/include -I$(LOCALBASE)/include/libelf \
	-D_FILE_OFFSET_BITS=64
   LIBS=-L$(LOCALBASE)/lib -L. -lelf $(PTHREAD_LIBS) $(LDFLAGS)
else
ifeq ($(shell uname), Linux)
   PTHREAD_LIBS?=-lpthread
   OSNAME=Linux
   CFLAGS+=-I/usr/include -I. -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/lib -L. -ldl -lrt -luuid -lelf $(PTHREAD_LIBS) $(LDFLAGS)
else
ifeq ($(shell uname), GNU/kFreeBSD)
   PTHREAD_LIBS?=-lpthread
   OSNAME=GNU/kFreeBSD
   CFLAGS+=-I/usr/include -I. -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/lib -L. -ldl -lrt -luuid -lelf $(PTHREAD_LIBS) $(LDFLAGS)
   DESTDIR=/usr
else
ifeq ($(shell uname -s), Darwin)
   OSNAME=Darwin
   CFLAGS+=-I/usr/local/include -I/opt/local/include -mdynamic-no-pic -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/local/lib -L/opt/local/lib -L. -ldl -lelf -lpthread
ifeq ($(DYNAMIPS_ARCH),amd64)
   CFLAGS+= -DMAC64HACK
endif
else
ifeq ($(shell uname -s), SunOS)
   OSNAME=SunOS
   CFLAGS+=-I/usr/local/include -DINADDR_NONE=0xFFFFFFFF \
	-I /opt/csw/include -DSUNOS
   LIBS=-L/usr/local/lib -L. -ldl -lelf -lpthread -L/opt/csw/lib \
	-lsocket -lnsl -lresolv
   PCAP_LIB=/opt/csw/lib/libpcap.a
else
ifeq ($(shell uname -o), Cygwin)
   OSNAME=Windows
   CFLAGS+=-I/usr/local/include -I/usr/local/include/libelf -I/usr/include -I/usr/include/libelf \
	-I/usr/include/winpcap -DCYGWIN -static -static-libgcc
   LIBS=-L/usr/local/lib -L/usr/lib -L. -lintl -lelf -lpthread -luuid
   PCAP_LIB=-lpacket -lwpcap
else
   CFLAGS+=-I/usr/include/libelf -D_FILE_OFFSET_BITS=64
   LIBS=-L. -ldl /usr/lib/libelf.a -lpthread
endif
endif
endif
endif
endif
endif

CFLAGS+=-DOSNAME=$(OSNAME)

PROG=dynamips$(BIN_EXT)

# Header and source files
HDR=mempool.h registry.h rbtree.h hash.h utils.h parser.h plugin.h \
	gen_uuid.h crc.h sbox.h base64.h \
	net.h net_io.h net_io_bridge.h net_io_filter.h \
	atm.h atm_vsar.h atm_bridge.h frame_relay.h eth_switch.h \
	ptask.h timer.h dev_vtty.h hypervisor.h dynamips.h insn_lookup.h \
	vm.h cpu.h jit_op.h memory.h device.h \
	mips64.h mips64_mem.h mips64_exec.h mips64_jit.h mips64_cp0.h \
	ppc32.h ppc32_mem.h ppc32_exec.h ppc32_jit.h ppc32_vmtest.h \
	nmc93cX6.h cisco_eeprom.h cisco_card.h dev_ds1620.h dev_rom.h \
	pci_dev.h pci_io.h dev_mpc860.h dev_gt.h dev_mv64460.h dev_plx.h \
	dev_dec21140.h dev_am79c971.h dev_i8254x.h dev_i8255x.h \
	dev_mueslix.h dev_nm_16esw.h dev_wic_serial.h \
	dev_c7200.h dev_c7200_mpfpga.h \
	dev_c3600.h dev_c3600_iofpga.h dev_c3600_bay.h \
	dev_c2691.h dev_c2691_iofpga.h \
	dev_c3725.h dev_c3725_iofpga.h \
	dev_c3745.h dev_c3745_iofpga.h \
	dev_c2600.h dev_c2600_iofpga.h \
	dev_c1700.h dev_c1700_iofpga.h \
	dev_c6msfc1.h dev_c6msfc1_mpfpga.h \
	dev_c6sup1.h dev_c6sup1_mpfpga.h \
	rommon_var.h get_cpu_time.h fs_nvram.h

SOURCES=mempool.c registry.c rbtree.c hash.c sbox.c utils.c parser.c \
	gen_uuid.c plugin.c ptask.c timer.c crc.c base64.c \
	net.c net_io.c net_io_bridge.c net_io_filter.c \
	atm.c atm_vsar.c atm_bridge.c frame_relay.c eth_switch.c \
	dynamips.c insn_lookup.c vm.c cpu.c jit_op.c \
	mips64.c mips64_mem.c mips64_cp0.c mips64_jit.c mips64_exec.c \
	ppc32.c ppc32_mem.c ppc32_jit.c ppc32_exec.c ppc32_vmtest.c \
	memory.c device.c nmc93cX6.c cisco_eeprom.c cisco_card.c \
	pci_dev.c pci_io.c \
	dev_zero.c dev_bswap.c dev_vtty.c dev_ram.c dev_rom.c dev_nvram.c \
	dev_bootflash.c dev_flash.c dev_mpc860.c dev_ds1620.c \
	dev_remote.c dev_clpd6729.c dev_pcmcia_disk.c dev_gt.c dev_mv64460.c \
	dev_plx.c dev_dec21x50.c dev_pericom.c dev_ti2050b.c dev_ap1011.c \
	dev_plx6520cb.c dev_ns16552.c \
	dev_dec21140.c dev_am79c971.c dev_i8254x.c dev_i8255x.c \
	dev_mueslix.c dev_wic_serial.c \
	dev_c3600.c dev_c3600_bay.c dev_c3600_iofpga.c \
	dev_c3600_eth.c dev_c3600_serial.c \
	dev_c7200.c dev_c7200_iofpga.c dev_c7200_mpfpga.c \
	dev_c7200_sram.c dev_c7200_eth.c dev_c7200_serial.c dev_c7200_pos.c \
	dev_c7200_bri.c dev_c7200_jcpa.c \
	dev_c2691.c dev_c2691_iofpga.c dev_c2691_eth.c dev_c2691_serial.c \
	dev_c2691_wic.c dev_c2691_pcmod.c \
	dev_c3725.c dev_c3725_iofpga.c dev_c3725_eth.c dev_c3725_serial.c \
	dev_c3725_wic.c dev_c3725_pcmod.c \
	dev_c3745.c dev_c3745_iofpga.c dev_c3745_eth.c dev_c3745_serial.c \
	dev_c3745_wic.c dev_c3745_pcmod.c \
	dev_c2600.c dev_c2600_pci.c dev_c2600_iofpga.c \
	dev_c2600_eth.c dev_c2600_pcmod.c dev_c2600_wic.c \
	dev_c1700.c dev_c1700_iofpga.c dev_c1700_eth.c dev_c1700_wic.c \
	dev_c6msfc1.c dev_c6msfc1_iofpga.c dev_c6msfc1_mpfpga.c \
	dev_c6sup1.c dev_c6sup1_iofpga.c dev_c6sup1_mpfpga.c \
	dev_nm_16esw.c dev_pa_a1.c dev_pa_mc8te1.c \
	dev_sb1.c dev_sb1_io.c dev_sb1_pci.c hypervisor.c \
	hv_nio.c hv_nio_bridge.c \
	hv_frsw.c hv_atmsw.c hv_atm_bridge.c hv_ethsw.c \
	hv_vm.c hv_vm_debug.c hv_store.c \
	hv_c7200.c hv_c3600.c hv_c2691.c hv_c3725.c hv_c3745.c \
	hv_c2600.c hv_c1700.c \
	rommon_var.c get_cpu_time.c fs_nvram.c

# Profiling
#SOURCES += profiler.c
#CFLAGS += -p -DPROFILE -DPROFILE_FILE=\"$(PROG).profile\"

#Debugging symbols (overrides optimization level)
#WITH_DEBUG=2
ifneq ($(WITH_DEBUG),)
CFLAGS+= -O$(WITH_DEBUG) -ggdb -fasynchronous-unwind-tables -fvar-tracking
endif

ifeq ($(DYNAMIPS_ARCH),x86)
HDR += x86-codegen.h mips64_x86_trans.h ppc32_x86_trans.h
SOURCES += mips64_x86_trans.c ppc32_x86_trans.c
CFLAGS += -m32
endif

ifeq ($(DYNAMIPS_ARCH),amd64)
HDR += x86-codegen.h amd64-codegen.h mips64_amd64_trans.h ppc32_amd64_trans.h
SOURCES += mips64_amd64_trans.c ppc32_amd64_trans.c
CFLAGS += -m64
endif

ifeq ($(DYNAMIPS_ARCH),nojit)
HDR += mips64_nojit_trans.h ppc32_nojit_trans.h
SOURCES += mips64_nojit_trans.c ppc32_nojit_trans.c
endif

# RAW Ethernet support for Linux
ifeq ($(shell uname), Linux)
CFLAGS += -DLINUX_ETH
HDR += linux_eth.h
SOURCES += linux_eth.c
endif

# Generic Ethernet support with libpcap (0.9+)
ifeq ($(HAS_PCAP), 1)
CFLAGS += -DGEN_ETH
HDR += gen_eth.h
SOURCES += gen_eth.c

LIBS += $(PCAP_LIB)
endif

C_OBJS=$(SOURCES:.c=.o)

SUPPL=mips_mts.c Makefile ChangeLog COPYING README README.hypervisor TODO \
	dynamips.1 nvram_export.1 hypervisor_mode.7 \
	mips64_microcode ppc32_microcode

FILE_LIST := $(HDR) $(SOURCES) $(SUPPL) \
	x86-codegen.h amd64-codegen.h \
	mips64_x86_trans.c mips64_x86_trans.h \
	mips64_amd64_trans.c mips64_amd64_trans.h \
	mips64_nojit_trans.c mips64_nojit_trans.h \
	ppc32_x86_trans.c ppc32_x86_trans.h \
	ppc32_amd64_trans.c ppc32_amd64_trans.h \
	ppc32_nojit_trans.c ppc32_nojit_trans.h \
	linux_eth.c linux_eth.h gen_eth.c gen_eth.h \
	profiler.c profiler_resolve.pl bin2c.c rom2c.c \
	nvram_export.c udp_send.c udp_recv.c

.PHONY: all
all: $(PROG) nvram_export$(BIN_EXT)

$(PROG): mips64_microcode_dump.inc ppc32_microcode_dump.inc \
	$(C_OBJS)
	@echo "Linking $@"
	@$(CC) $(CFLAGS) -o $@ $(C_OBJS) $(LIBS)

udp_send$(BIN_EXT): udp_send.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_send.c net.c crc.c $(LIBS)

udp_recv$(BIN_EXT): udp_recv.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_recv.c net.c crc.c $(LIBS)

rom2c$(BIN_EXT): rom2c.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ $< $(LIBS)

mips64_microcode_dump.inc: rom2c$(BIN_EXT) mips64_microcode
	@./rom2c$(BIN_EXT) mips64_microcode mips64_microcode_dump.inc 0xbfc00000

ppc32_microcode_dump.inc: rom2c$(BIN_EXT) ppc32_microcode
	@./rom2c$(BIN_EXT) ppc32_microcode ppc32_microcode_dump.inc 0xfff00000

# explicit dependencies needed for parallel jobs
dev_rom.c: mips64_microcode_dump.inc ppc32_microcode_dump.inc

nvram_export$(BIN_EXT): nvram_export.o fs_nvram.o
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) $(INCLUDE) $(LDFLAGS) -o $@ nvram_export.o fs_nvram.o

.PHONY: clean
clean:
	$(RM) -f rom2c$(BIN_EXT) microcode_dump.inc \
	$(C_OBJS) $(PROG) nvram_export$(BIN_EXT) nvram_export.o \
	mips64_microcode_dump.inc ppc32_microcode_dump.inc
	$(RM) -f *~

.SUFFIXES: .c .o

.c.o:
	@echo "Compiling $<"
	@$(CC) $(CPPFLAGS) $(CFLAGS) $(INCLUDE) -c -o $*.o $<

=== unstable/Makefile ===
# Unstable Makefile for Dynamips
# Copyright (c) 2005-2006 Christophe Fillot.
# Copyright (c) 2013 Daniel Lintott.

# Get include files from the current directory and from the common directory
INCLUDE+=-I. -I../common

VERSION=$(VERSION_TRAIN)$(VERSION_SUB)
VERSION_DEV=$(VERSION_TRAIN)-$(shell date +%Y%m%d-%H)

# If make cannot find a file, try the common directory
VPATH = ../common

CC?=gcc
RM=rm
TAR=tar
CP=cp
MIPS64_ARCH_INC_FILE=\"mips64_$(DYNAMIPS_ARCH)_trans.h\"
PPC32_ARCH_INC_FILE=\"ppc32_$(DYNAMIPS_ARCH)_trans.h\"
OSNAME=unknown

CFLAGS+= $(INCLUDE) -m32 -Wall -O2 -fomit-frame-pointer \
	-DJIT_ARCH=\"$(DYNAMIPS_ARCH)\" -DJIT_CPU=CPU_$(DYNAMIPS_ARCH) \
	-DMIPS64_ARCH_INC_FILE=$(MIPS64_ARCH_INC_FILE) \
	-DPPC32_ARCH_INC_FILE=$(PPC32_ARCH_INC_FILE) \
	-DDYNAMIPS_VERSION=\"$(VERSION)\" \
	-D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE \
	-DHAS_RFC2553=$(HAS_RFC2553) \
	-DHAS_POSIX_MEMALIGN=$(HAS_POSIX_MEMALIGN) \
	-DUSE_UNSTABLE

PCAP_LIB?=-lpcap

ifeq ($(shell uname), FreeBSD)
   PTHREAD_LIBS?=-pthread
   LOCALBASE?=/usr/local
   OSNAME=FreeBSD
   CFLAGS+=-I$(LOCALBASE)/include -I$(LOCALBASE)/include/libelf \
	-D_FILE_OFFSET_BITS=64
   LIBS=-L$(LOCALBASE)/lib -L. -lelf $(PTHREAD_LIBS) $(LDFLAGS)
else
ifeq ($(shell uname), Linux)
   PTHREAD_LIBS?=-lpthread
   OSNAME=Linux
   CFLAGS+=-I/usr/include -I. -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/lib -L. -ldl -lrt -luuid -lelf $(PTHREAD_LIBS) $(LDFLAGS)
else
ifeq ($(shell uname), GNU/kFreeBSD)
   PTHREAD_LIBS?=-lpthread
   OSNAME=GNU/kFreeBSD
   CFLAGS+=-I/usr/include -I. -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/lib -L. -ldl -lrt -luuid -lelf $(PTHREAD_LIBS) $(LDFLAGS)
   DESTDIR=/usr
else
ifeq ($(shell uname -s), Darwin)
   OSNAME=Darwin
   CFLAGS+=-I/usr/local/include -I/opt/local/include/libelf -mdynamic-no-pic -D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/local/lib -L/opt/local/lib -L. -ldl -lelf -lpthread
else
ifeq ($(shell uname -s), SunOS)
   OSNAME=SunOS
   CFLAGS+=-I/usr/local/include -DINADDR_NONE=0xFFFFFFFF \
	-I /opt/csw/include -DSUNOS
   LIBS=-L/usr/local/lib -L. -ldl -lelf -lpthread -L/opt/csw/lib \
	-lsocket -lnsl -lresolv
   PCAP_LIB=/opt/csw/lib/libpcap.a
else
ifeq ($(shell uname -o), Cygwin)
   OSNAME=Windows
   CFLAGS+=-I/usr/local/include -I/usr/local/include/libelf -I/usr/include/winpcap -DCYGWIN \
	-D_FILE_OFFSET_BITS=64
   LIBS=-L/usr/local/lib -L. -lelf -lpthread -luuid
   PCAP_LIB=-lpacket -lwpcap
else
   CFLAGS+=-I/usr/include/libelf -D_FILE_OFFSET_BITS=64
   LIBS=-L. -ldl /usr/lib/libelf.a -lpthread
endif
endif
endif
endif
endif
endif

CFLAGS+=-DOSNAME=$(OSNAME)

PROG=dynamips$(BIN_EXT)

# Header and source files
HDR=mempool.h registry.h rbtree.h hash.h utils.h parser.h plugin.h \
	gen_uuid.h crc.h sbox.h base64.h \
	net.h net_io.h net_io_bridge.h net_io_filter.h \
	atm.h atm_vsar.h atm_bridge.h frame_relay.h eth_switch.h \
	ptask.h timer.h dev_vtty.h hypervisor.h dynamips.h insn_lookup.h \
	vm.h cpu.h tcb.h jit_op.h memory.h device.h \
	mips64.h mips64_mem.h mips64_exec.h mips64_jit.h mips64_cp0.h \
	ppc32.h ppc32_mem.h ppc32_exec.h ppc32_jit.h ppc32_vmtest.h \
	nmc93cX6.h cisco_eeprom.h cisco_card.h dev_ds1620.h dev_rom.h \
	pci_dev.h pci_io.h dev_mpc860.h dev_gt.h dev_mv64460.h dev_plx.h \
	dev_dec21140.h dev_am79c971.h dev_i8254x.h dev_i8255x.h \
	dev_mueslix.h dev_nm_16esw.h dev_wic_serial.h \
	dev_c7200.h dev_c7200_mpfpga.h \
	dev_c3600.h dev_c3600_iofpga.h dev_c3600_bay.h \
	dev_c2691.h dev_c2691_iofpga.h \
	dev_c3725.h dev_c3725_iofpga.h \
	dev_c3745.h dev_c3745_iofpga.h \
	dev_c2600.h dev_c2600_iofpga.h \
	dev_c1700.h dev_c1700_iofpga.h \
	dev_c6msfc1.h dev_c6msfc1_mpfpga.h \
	dev_c6sup1.h dev_c6sup1_mpfpga.h \
	rommon_var.h get_cpu_time.h fs_nvram.h

SOURCES=mempool.c registry.c rbtree.c hash.c sbox.c utils.c parser.c \
	gen_uuid.c plugin.c ptask.c timer.c crc.c base64.c \
	net.c net_io.c net_io_bridge.c net_io_filter.c \
	atm.c atm_vsar.c atm_bridge.c frame_relay.c eth_switch.c \
	dynamips.c insn_lookup.c vm.c cpu.c tcb.c jit_op.c \
	mips64.c mips64_mem.c mips64_cp0.c mips64_jit.c mips64_exec.c \
	ppc32.c ppc32_mem.c ppc32_jit.c ppc32_exec.c ppc32_vmtest.c \
	memory.c device.c nmc93cX6.c cisco_eeprom.c cisco_card.c \
	pci_dev.c pci_io.c \
	dev_zero.c dev_bswap.c dev_vtty.c dev_ram.c dev_rom.c dev_nvram.c \
	dev_bootflash.c dev_flash.c dev_mpc860.c dev_ds1620.c \
	dev_remote.c dev_clpd6729.c dev_pcmcia_disk.c dev_gt.c dev_mv64460.c \
	dev_plx.c dev_dec21x50.c dev_pericom.c dev_ti2050b.c dev_ap1011.c \
	dev_plx6520cb.c dev_ns16552.c \
	dev_dec21140.c dev_am79c971.c dev_i8254x.c dev_i8255x.c \
	dev_mueslix.c dev_wic_serial.c \
	dev_c3600.c dev_c3600_bay.c dev_c3600_iofpga.c \
	dev_c3600_eth.c dev_c3600_serial.c \
	dev_c7200.c dev_c7200_iofpga.c dev_c7200_mpfpga.c \
	dev_c7200_sram.c dev_c7200_eth.c dev_c7200_serial.c dev_c7200_pos.c \
	dev_c7200_bri.c dev_c7200_jcpa.c \
	dev_c2691.c dev_c2691_iofpga.c dev_c2691_eth.c dev_c2691_serial.c \
	dev_c2691_wic.c dev_c2691_pcmod.c \
	dev_c3725.c dev_c3725_iofpga.c dev_c3725_eth.c dev_c3725_serial.c \
	dev_c3725_wic.c dev_c3725_pcmod.c \
	dev_c3745.c dev_c3745_iofpga.c dev_c3745_eth.c dev_c3745_serial.c \
	dev_c3745_wic.c dev_c3745_pcmod.c \
	dev_c2600.c dev_c2600_pci.c dev_c2600_iofpga.c \
	dev_c2600_eth.c dev_c2600_pcmod.c dev_c2600_wic.c \
	dev_c1700.c dev_c1700_iofpga.c dev_c1700_eth.c dev_c1700_wic.c \
	dev_c6msfc1.c dev_c6msfc1_iofpga.c dev_c6msfc1_mpfpga.c \
	dev_c6sup1.c dev_c6sup1_iofpga.c dev_c6sup1_mpfpga.c \
	dev_nm_16esw.c dev_pa_a1.c dev_pa_mc8te1.c \
	dev_sb1.c dev_sb1_io.c dev_sb1_pci.c hypervisor.c \
	hv_nio.c hv_nio_bridge.c \
	hv_frsw.c hv_atmsw.c hv_atm_bridge.c hv_ethsw.c \
	hv_vm.c hv_vm_debug.c hv_store.c \
	hv_c7200.c hv_c3600.c hv_c2691.c hv_c3725.c hv_c3745.c \
	hv_c2600.c hv_c1700.c \
	rommon_var.c get_cpu_time.c fs_nvram.c

# Profiling
#SOURCES += profiler.c
#CFLAGS += -p -DPROFILE -DPROFILE_FILE=\"$(PROG).profile\"

#Debugging symbols (overrides optimization level)
#WITH_DEBUG=2
ifneq ($(WITH_DEBUG),)
CFLAGS+= -O$(WITH_DEBUG) -ggdb -fasynchronous-unwind-tables -fvar-tracking
endif

ifeq ($(DYNAMIPS_ARCH),x86)
HDR += x86-codegen.h mips64_x86_trans.h ppc32_x86_trans.h
SOURCES += mips64_x86_trans.c ppc32_x86_trans.c
CFLAGS += -m32
endif

ifeq ($(DYNAMIPS_ARCH),amd64)
HDR += x86-codegen.h amd64-codegen.h mips64_amd64_trans.h ppc32_amd64_trans.h
SOURCES += mips64_amd64_trans.c ppc32_amd64_trans.c
CFLAGS += -m64
endif

ifeq ($(DYNAMIPS_ARCH),ppc32)
HDR += mips64_ppc32_trans.h ppc32_ppc32_trans.h
SOURCES += mips64_ppc32_trans.c ppc32_ppc32_trans.c
CFLAGS += -m32
endif

ifeq ($(DYNAMIPS_ARCH),nojit)
HDR += mips64_nojit_trans.h ppc32_nojit_trans.h
SOURCES += mips64_nojit_trans.c ppc32_nojit_trans.c
endif

# RAW Ethernet support for Linux
ifeq ($(shell uname), Linux)
CFLAGS += -DLINUX_ETH
HDR += linux_eth.h
SOURCES += linux_eth.c
endif

# Generic Ethernet support with libpcap (0.9+)
ifeq ($(HAS_PCAP), 1)
CFLAGS += -DGEN_ETH
HDR += gen_eth.h
SOURCES += gen_eth.c

LIBS += $(PCAP_LIB)
endif

C_OBJS=$(SOURCES:.c=.o)

SUPPL=mips_mts.c Makefile ChangeLog COPYING README README.hypervisor TODO \
	dynamips.1 nvram_export.1 hypervisor_mode.7 \
	mips64_microcode ppc32_microcode

FILE_LIST := $(HDR) $(SOURCES) $(SUPPL) \
	x86-codegen.h amd64-codegen.h ppc-codegen.h \
	mips64_x86_trans.c mips64_x86_trans.h \
	mips64_amd64_trans.c mips64_amd64_trans.h \
	mips64_nojit_trans.c mips64_nojit_trans.h \
	ppc32_x86_trans.c ppc32_x86_trans.h \
	ppc32_amd64_trans.c ppc32_amd64_trans.h \
	ppc32_nojit_trans.c ppc32_nojit_trans.h \
	mips64_ppc32_trans.c mips64_ppc32_trans.h \
	linux_eth.c linux_eth.h gen_eth.c gen_eth.h \
	profiler.c profiler_resolve.pl bin2c.c rom2c.c \
	nvram_export.c udp_send.c udp_recv.c

.PHONY: all
all: $(PROG) nvram_export$(BIN_EXT)

$(PROG): mips64_microcode_dump.inc ppc32_microcode_dump.inc \
	$(C_OBJS) $(A_OBJS)
	@echo "Linking $@"
	@$(CC) $(CFLAGS) -o $@ $(C_OBJS) $(LIBS)

udp_send$(BIN_EXT): udp_send.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_send.c net.c crc.c $(LIBS)

udp_recv$(BIN_EXT): udp_recv.c net.c crc.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ udp_recv.c net.c crc.c $(LIBS)

rom2c$(BIN_EXT): rom2c.c
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) -o $@ $< $(LIBS)

mips64_microcode_dump.inc: rom2c$(BIN_EXT) mips64_microcode
	@./rom2c$(BIN_EXT) mips64_microcode mips64_microcode_dump.inc 0xbfc00000

ppc32_microcode_dump.inc: rom2c$(BIN_EXT) ppc32_microcode
	@./rom2c$(BIN_EXT) ppc32_microcode ppc32_microcode_dump.inc 0xfff00000

# explicit dependencies needed for parallel jobs
dev_rom.c: mips64_microcode_dump.inc ppc32_microcode_dump.inc

nvram_export$(BIN_EXT): nvram_export.o fs_nvram.o
	@echo "Linking $@"
	@$(CC) -Wall $(CFLAGS) $(INCLUDE) $(LDFLAGS) -o $@ nvram_export.o fs_nvram.o

.PHONY: clean
clean:
	$(RM) -f rom2c$(BIN_EXT) microcode_dump.inc \
	$(C_OBJS) $(PROG) nvram_export$(BIN_EXT) nvram_export.o \
	mips64_microcode_dump.inc ppc32_microcode_dump.inc
	$(RM) -f *~

.SUFFIXES: .c .o

.c.o:
	@echo "Compiling $<"
	@$(CC) $(CPPFLAGS) $(CFLAGS) $(INCLUDE) -c -o $*.o $<

=== debian/changelog ===
dynamips (0.2.11-1) unstable; urgency=low

  * [ab3a8d82] Bump standards-version to 3.9.5 - no changes
  * [b792229e] debian/watch - Remove obsolete githubredir
  * [278818eb] Imported Upstream version 0.2.11
  * [f1fec7b5] Drop patches applied upstream
		     + 20-stableMakefileHardening
		     + 30-arm_support.patch
  * [4a4ab133] Patches to fix architecture detection in Makefile
		     + 10-Makefile-Architecture - removed
		     + MakefileArchitecture.patch - added
  * [98e2662c] debian/rules
                     + Remove override_dh_install (Makefile fixed for DESTDIR)
  * [4ec13364] Add patch to fix lintian warning:
                 + manpage-has-errors-from-man 
		   hypervisor_mode.7.gz 310: warning: macro `Bvm' not defined

 -- Daniel Lintott <daniel@serverb.co.uk>  Tue, 11 Feb 2014 11:20:41 +0000

dynamips (0.2.10-2) unstable; urgency=low

  * [6864f823] Import ARM Support patch from Ubuntu
  * [d3ad6218] Update Makefile architecture patch (to fix FTBFS on Ubuntu)
  * [0e8239c6] Update ARM Support patch to include ARM64

 -- Daniel Lintott <daniel@serverb.co.uk>  Tue, 29 Oct 2013 12:33:09 +0000

dynamips (0.2.10-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Enable autobuild.

 -- Andrew Shadura <andrewsh@debian.org>  Thu, 17 Oct 2013 22:46:37 +0200

dynamips (0.2.10-1) unstable; urgency=low

  * New Maintainer (Closes: #725349)
  * [f0fade5c] Imported Upstream version 0.2.10
  * [49cfc9c2] Add new architecture patch
  * [3c9594b0] Correct spelling in README.debian
  * [642bb50c] Switch build system to debhelper
  * [cd423ffa] Update debian/watch file
  * [c1920d03] Add additional files for debhelper
  * [c4623795] Convert copyright file to machine readable (DEP-5)
  * [4e7cb75b] Add postinst script
  * [ddeaf0eb] Update debian/control

 -- Daniel Lintott <daniel@serverb.co.uk>  Mon, 07 Oct 2013 19:28:57 +0100

=== debian/control ===
Source: dynamips
Section: non-free/net
Priority: optional
Maintainer: Daniel Lintott <daniel@serverb.co.uk>
Build-Depends: debhelper (>= 9), libpcap0.8-dev (>= 0.9.0), libelf-dev, uuid-dev
Standards-Version: 3.9.5
Homepage: http://www.gns3.net
Vcs-Browser: https://github.com/dlintott/dynamips
Vcs-Git: https://github.com/dlintott/dynamips.git
XS-Autobuild: yes

Package: dynamips
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: gns3
Description: Cisco 7200/3600/3725/3745/2600/1700 Router Emulator
 Dynamips emulates Cisco 7200/3600/3725/3745/2600/1700 Routers on a traditional
 PC.  You can use dynamips to create labs. It uses IOS Images (which are not
 part of this package). Of course, this emulator cannot replace a real router.
 .
 It is simply a complementary tool to real labs for administrators of Cisco
 networks or people wanting to pass their CCNA/CCNP/CCIE exams. For a Command
 Line Interface for dynamips see dynagen or gns3 package.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_compress:
	dh_compress -XREADME

## dynamips 0.2.12

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
 export HAS_POSIX_MEMALIGN?=1
 
 # Current dynamips release
-export VERSION_TRAIN=0.2.11
+export VERSION_TRAIN=0.2.12
 export VERSION_SUB=
 
 # Executable binary extension and prefix directory

=== debian/changelog ===
dynamips (0.2.12-1) unstable; urgency=medium

  * Correct my email address in d/copyright
  * Imported Upstream version 0.2.12
  * Remove patch applied upstream
    + 0001-Missing-space-in-hypervisor_mode.7-manpage-line-310.patch
  * Wrap-and-sort d/control and d/copyright
  * Move VCS to Alioth
  * Update debian/copyright
  * Drop version from libpcap0.8-dev build-depend
  * Drop un-necessary override in d/rules

 -- Daniel Lintott <daniel@serverb.co.uk>  Sat, 05 Apr 2014 20:18:59 +0100

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,24 @@
 Section: non-free/net
 Priority: optional
 Maintainer: Daniel Lintott <daniel@serverb.co.uk>
-Build-Depends: debhelper (>= 9), libpcap0.8-dev (>= 0.9.0), libelf-dev, uuid-dev
+Build-Depends:
+ debhelper (>= 9),
+ libelf-dev,
+ libpcap0.8-dev,
+ uuid-dev
 Standards-Version: 3.9.5
 Homepage: http://www.gns3.net
-Vcs-Browser: https://github.com/dlintott/dynamips
-Vcs-Git: https://github.com/dlintott/dynamips.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/dlintott-guest/dynamips.git
+Vcs-Git: git://anonscm.debian.org/users/dlintott-guest/dynamips.git
 XS-Autobuild: yes
 
 Package: dynamips
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: gns3
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends}
+Suggests:
+ gns3
 Description: Cisco 7200/3600/3725/3745/2600/1700 Router Emulator
  Dynamips emulates Cisco 7200/3600/3725/3745/2600/1700 Routers on a traditional
  PC.  You can use dynamips to create labs. It uses IOS Images (which are not
